// Camera.h: Schnittstelle fr die Klasse Camera
//
//////////////////////////////////////////////////////////////////////

#ifndef CAMERA_H
#define CAMERA_H

#include<math.h>
#include"Quaternion.h"

#define UP              0.10f//0.01f             // forward speed
#define DOWN            -0.10f//-0.01f            // backward speed
#define LEFT            0.7f              // left speed
#define RIGHT           -0.7f             // right speed
#define STRAFE_LEFT     -0.10f//-0.01f            // left strafe speed
#define STRAFE_RIGHT    0.10f//0.01f             // right strafe speed


class Camera
{
   public:

       // constructors/destructors
	   Camera();

	   // methods
	   void SetCamera(float x, float y, float z,
                      float xv, float yv, float zv,
                      float xu, float yu, float zu);
	   void UpdateCamera(float xDir, float yDir,
                         float zDir, float dir);
	   void MoveCamera(float direction);
	   void CalculateStrafe();
	   void StrafeCamera(float direction);
	   void RotateCamera(float AngleDir, float xSpeed,
                         float ySpeed, float zSpeed);
	   void RotateByMouse(int mousePosX, int mousePosY,
                          int midX, int midY);

	   // fields
	   float xPos, yPos, zPos;                         // camera position
	   float xView, yView, zView;                      // look at point
       float xUp, yUp, zUp;                            // up direction
       float xStrafe, yStrafe, zStrafe;                // strafe direction
       float currentRotationAngle;                     // prevents going too far up or down
};

#endif