/*
www.UltimateGameProgramming.com
Basic Vertex Shader in GLSlang.
Created by the Programming Ace.


Input...
   gl_Vertex = vertex object space position.
   gl_Color = vertex in color.
   gl_ModelViewProjectionMatrix = current model view projection matrix.


Varying...
   color = output vertex color.


Output...
   gl_Position = vertex object space position.
*/


// color will be passed to the pixel shader.
varying vec4 color;


void main()
{
   // glPosition is a built in variable that stores the output vertex position.
   // Here we multiply the object space vertex (gl_Vertex) by the model view
   // projection matrix to transform the vertex to clip space.
   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
   
   // We simple pass the color we got from gl_Color3f() to the varying color
   // variable.  Varying variables allow us to send values to the fragment shader.
   // This color will be interpolated across the surface automatically to give us
   // a gradient effect.
   color = gl_Color;
   //color = {gl_color[0]+0.1,gl_color[1]-0.1,gl_color[2]+0.1};
}