// Shader.h: Schnittstelle fr die Klasse Shader
//
//////////////////////////////////////////////////////////////////////


#ifndef SHADER_H
#define SHADER_H

#include <fstream>
#include <GL/glut.h>
#include <GL/glext.h>

using std::ifstream;


// glsl functions
extern PFNGLCREATEPROGRAMOBJECTARBPROC glCreateProgramObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC glCreateShaderObjectARB;
extern PFNGLLINKPROGRAMARBPROC glLinkProgramARB;
extern PFNGLCOMPILESHADERARBPROC glCompileShaderARB;
extern PFNGLGETINFOLOGARBPROC glGetInfoLogARB;
extern PFNGLDELETEOBJECTARBPROC glDeleteObjectARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC glUseProgramObjectARB;
extern PFNGLSHADERSOURCEARBPROC glShaderSourceARB;
extern PFNGLATTACHOBJECTARBPROC glAttachObjectARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC glGetObjectParameterivARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC glGetUniformLocationARB;
extern PFNGLGETATTRIBLOCATIONARBPROC glGetAttribLocationARB;
extern PFNGLUNIFORMMATRIX4FVARBPROC glUniformMatrix4fvARB;
extern PFNGLUNIFORM4FARBPROC glUnifrom4fARB;
extern PFNGLUNIFORM2FARBPROC glUniform2fARB;
extern PFNGLUNIFORM1FARBPROC glUniform1fARB;
extern PFNGLUNIFORM1IARBPROC glUniform1iARB;

// methods
		
bool InitializeGLSL();
bool isLoaded();
bool LoadShaders(char* vertexShader, char* pixelShader, GLhandleARB* glContext);
char* loadShader(char* shaderName);
void clearShaders();
void printInfoLog(GLhandleARB glContext);

// fields

	

#endif